/* 
 * Criado por Bruno R. Lima em 22/03/2005
 */
package br.com.csvconverter;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

import br.com.csvparser.CSVDefaultReader;
import br.com.csvparser.CSVDefaultWriter;

/**
 * 
 * @author Bruno Rios Lima
 */
public class CSVExcelConverter {

    public static void main(String[] args) throws Exception {
        
        String fileName = "src/file.xls";
        
        // for sheet name
        /*HSSFWorkbook wb = new HSSFWorkbook();
        wb.setSheetName(0,"Folha 1");
        HSSFSheet s = wb.createSheet("FolhaTeste");
        s.createRow(0).createCell((short)0).setCellValue("Teste");
        wb.write(new FileOutputStream(new File(fileName)));*/

        
        CSVDefaultReader r = new CSVExcelConverter().getCSVReaderFromExcel(new FileInputStream(new File(fileName)));
        r.printContents();
        
        /*HSSFSheet s = wb.createSheet();
        wb.setSheetName( 0, "SomeUnicodeName" );

        // for cell value
        HSSFRow r = s.createRow( 0 );
        HSSFCell c = r.createCell( (short)0 );
        c.setCellType( HSSFCell.CELL_TYPE_STRING );
        c.setCellValue( "Teste" );*/
        
        
    }
    
    // return a reader to each sheet
    public CSVDefaultWriter getCSVWriterFromExcel(FileInputStream file) throws IOException{
        
        HSSFWorkbook wb = new HSSFWorkbook(file);
        CSVDefaultWriter writer = new CSVDefaultWriter();
        
        HSSFSheet s = wb.getSheetAt(0);
        HSSFRow r = null;
        HSSFCell c = null;
        int lastRow = s.getLastRowNum();
        
        for( int row=0; row<=lastRow; row++ ){
            r = s.getRow(row);
            if( r != null ){
	            int lastCol = r.getLastCellNum();
	            writer.insertRow(null);
	            for( int col=0; col<lastCol; col++ ){
	                String val = "";
	                if( r.getCell((short)col) != null ){
	                    c = r.getCell((short)col);
	                    if( c.getCellType() == HSSFCell.CELL_TYPE_STRING )
	                        val = r.getCell((short)col).getStringCellValue();
	                    else if( c.getCellType() == HSSFCell.CELL_TYPE_NUMERIC )
	                        val = Double.toString(r.getCell((short)col).getNumericCellValue());
	                    else if( c.getCellType() == HSSFCell.CELL_TYPE_BOOLEAN )
	                        val = Boolean.toString(r.getCell((short)col).getBooleanCellValue());
	                }
	                writer.insertVal(val);
	            }
            }
        }
        file.close();
        return writer;
    }
    
    public CSVDefaultReader getCSVReaderFromExcel(FileInputStream file) throws IOException{
        return new CSVDefaultReader(getCSVWriterFromExcel(file));
    }
    
    public void saveAsExcelFile(CSVDefaultReader reader, FileOutputStream file) throws IOException{
        
        HSSFWorkbook wb = new HSSFWorkbook();
        HSSFSheet s = wb.createSheet(reader.getName());
        HSSFRow r = null;
        
        for( int row=0; row<reader.getRowCount(); row++){
            String[] line = (String[])reader.getRow(row);
            r = s.createRow(row);
            for(int col=0; col<line.length;col++){
                //ln.add(line[col]);
                r.createCell((short)col).setCellValue(line[col]);
            }
        }
        
        // write content
        wb.write(file);
        file.close();
        
        System.out.println("Sucessfully saved file!");
        
    }
     
}
